/*****************************************************************************
*program wzawierajacy mozliwie proste uzycie funkcji fortranowskiej (BLAS) 
* DNRM2() obliczajacej 2 norme wektora w podowjenje precyzji (double)
*w C kompiluje sie go komenda: gcc  test-blas.c -lm -lblas -lg2c  
*****************************************************************************/
#include"blas.h" 
#include"stdlib.h" 

/* plik wsadowy zawieRajacy prototypy funckji  BLASu np
		   dnrm2_() - orginal fortranowski :
		   DOUBLE PRECISION DNRM2(N,X,INCX)
		   * SCALAR ARGUMENTS
		   INTEGER INCX,N
		   *ARRAY ARGUMENT 
		   DOUBLE PRECISION X(*)
		  */ 

#include"CPUtimer.h" /* plik wsadowy f timer() - stoppera CPU*/
/* w razie braku tej funkcji  wykomentowac powyzsza linie i funkcje timer() */

#include<stdio.h>
#include<math.h>

#define lcol 400001



  
int main (void)
{
 double *v=NULL,*w=NULL;
 double norma=-1.0;
 int n,k=0,l=0;
 int INCX=1,INCY=1;
 
 
 v=(double *)malloc(lcol*sizeof(double));
 w=(double *)malloc(lcol*sizeof(double));
 printf("Timer start!\n");
 CPUtimer('s');
 for(l=0;l< lcol;l++)
 {
   v[l]=w[l]=1.0; 
   if(2*(l/2)-l) w[l]=-w[l];
 } 
 
 n = lcol;
 
 norma = dnrm2_(&n,v,&INCX);
 printf("\nNorma wektora dl %d o wartosciah v(l)=1 : %g\n",n,norma);

 
 norma = ddot_(&n,v,&INCX,w,&INCY);
 printf("Iloczyn skalarny wektorow  (0 gdy %d parzyste, 1 wpp) = %g\n",n,norma);
 printf("Timer czas:%g\n",CPUtimer('k'));

 free(v);
 free(w);
 
 return 0;
}
